#include <gmp.h>
#include "all.h"
#include "../blowfish/common.h"

#define DS_NICK_HASHSIZE 1

struct DS_blowfish {
	WORD08 *blowfish_key; /* [72]*/
	WORD32 blowfish_length;
	WORD32 blowfish_sched[1042];  /*[1042];*/
	bool blowfish_init;
	};	

struct node_nick_list {
	struct node_nick_list *next;
	char *nick; /* tolower */
	char *onick; /* "original" */
	char *host; /* host */
	char *username; /* find out yourself */
	char *realname; /* the same */
	time_t last_heard_of; /* the last time there was new information from or about */
/*	bool rsa_pub; *//* have we got a public key? */
	mpz_t rsa_n;
	mpz_t rsa_e; /* n and e from the rsa public key */
	/* blowfish for channel... what to do if there are more channels? */
	/* blowfish key for query */
	struct node_nick_channel_list *channell;
	};

struct node_channel_nick_list { /* this is for the nicklist in the channel data structure */
	struct node_channel_nick_list *next;
	struct node_nick_list *ptr; /* pointer to the nick */
	};

struct node_channel_list {
	struct node_channel_list *next;
	char *name;
	char *topic;
	struct node_channel_nick_list *nickl;
	};

struct node_nick_channel_list { /* this is for the channellist in the nick data structure */
	struct node_nick_channel_list *next;
	struct node_channel_list *ptr; /* pointer to the nick */
	};

struct node_s_list {
	struct node_server_list *next;
	struct node_channel_list *DS_channel;
	struct node_nick_list *DS_nick[DS_NICK_HASHSIZE];
	int SOCKET; /* the socket to read and write from/to */
	char *NICKNAME; /* your nickname on this server */
	char *SERVER; /* the server hostname (ip? i'm not sure if possible) */
	char *PCHANNEL; /* primaery channel, till... we are further :-) */
	char *SOCKBUF;
	int SOCKBUF_POS;
	int SOCKBUF_SIZE;
	};


struct DS_blowfish *DS_blowfish_init();
void DS_blowfish_schedule(struct DS_blowfish *input);


/* ######################################################## */
/* for the NICKS                                            */

/* for the nick data strcuture */

/* this returns a hash value for the given string, the
   string should have been set tolower allready...          */      
unsigned DS_nick_hash(char *s);
/* this returns a pointer to the data structure of the      */
/* given nick                                               */
struct node_nick_list *DS_nick_lookup(struct node_s_list *this_DS_s, char *nick);
struct node_nick_list *DS_nick_install(struct node_s_list *this_DS_s, char *onick);
bool DS_nick_undef(struct node_s_list *this_DS_s, char *onick);
void DS_nick_giveall(struct node_s_list *this_DS_s);


/* ######################################################## */
/* for the CHANNELS                                         */

struct node_channel_list *DS_channel_lookup(struct node_s_list *this_DS_s, char *s);
struct node_channel_list *DS_channel_install(struct node_s_list *this_DS_s, char *name);
int DS_channel_undef(struct node_s_list *this_DS_s, char *name);
void DS_channel_giveall(struct node_s_list *this_DS_s);

/* #####################################
   for the list of nicks in the channel data structure */

bool DS_channel_nick_add(struct node_s_list *this_DS_s, char *channel, char *nick);
bool DS_channel_nick_del(struct node_s_list *this_DS_s, char *channel, char *nick);
/* this function is intended to give us a space separated list
with the nicks in the given channel or NULL if something goes wrong */
char *DS_channel_nick_list(struct node_s_list *this_DS_s, char *channel);

char *irc_tolower(char *input);

