/* 
    SIT - SIS is tiny, intended to be a IRC Client for secure communication
	on top of the IRC protocol as described in RFC 1459
    Copyright (C) 2000  Christian Leber

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    e-mail: c_l@bigfoot.com
    I hope this is GPL compliant, if not please contact me.

    This is 'public domain' in the sense of the Wassenaar treaty.
*/

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <gmp.h>
#include <assert.h>

#include "rsa.h"
#include "all.h"

//int clrsa_single_mpz_to_raw2(unsigned char *output,mpz_t input);
//int clrsa_single_raw2_to_mpz(mpz_t output, unsigned char *input);

 
bool clrsa_single_mpz_encrypt(mpz_t output, clrsa_public input_key, mpz_t input)
{
/*	unsigned long length2, length8, i;
	mpz_t rem, back;
	div_t erg;		
*/	
	/* proof if input > 0 */
/*	if(mpz_cmp_ui(input,0)<=0) return 1;

	length2=mpz_sizeinbase(input,2);

	erg=div(length2,8);
	if(erg.rem==0) length8 = erg.quot;
		else length8 = erg.quot + 1;
		
	if(length8>254) return 1;
*/	
/*	output = (unsigned char*)malloc(length8+1);*/
/*	output[0] = length8;
	
	mpz_init(rem);
	mpz_init_set(back,input);

    for (i=1;i<=length8;i++)
	{
		mpz_tdiv_qr_ui (back, rem, back, 256);
		output[i]=mpz_get_ui (rem);
    }

	mpz_clear(back);
	mpz_clear(rem);
	
	for(i=0;i<=output[0];i++){printf("%u ",output[i]);}printf("\n");

	return 0;



*/

	return true;
}

int clrsa_single_mpz_to_raw2(unsigned char *output,mpz_t input)
{
	unsigned long length2, length8, i;
	mpz_t rem, back;
	div_t erg;		
	
	/* proof if input > 0 */
	if(mpz_cmp_ui(input,0)<=0) return 1;

	length2=mpz_sizeinbase(input,2);

	erg=div(length2,8);
	if(erg.rem==0) length8 = erg.quot;
		else length8 = erg.quot + 1;
		
	if(length8>254) return 1;
	
/*	output = (unsigned char*)malloc(length8+1);*/
	output[0] = length8;
	
	mpz_init(rem);
	mpz_init_set(back,input);

    for (i=1;i<=length8;i++)
	{
		mpz_tdiv_qr_ui (back, rem, back, 256);
		output[i]=mpz_get_ui (rem);
    }

	mpz_clear(back);
	mpz_clear(rem);
	
	for(i=0;i<=output[0];i++){printf("%u ",output[i]);}printf("\n");

	return 0;
}

int clrsa_single_raw2_to_mpz(mpz_t output, unsigned char *input)
{
	int i;
	mpz_init(output);

    for (i=input[0];i>=1;i--)	{
		mpz_mul_2exp (output, output, 8);
		mpz_add_ui (output, output, input[i]);
    }

	return 0;
}